Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -1040,60 +1061,60 @@
 !------------------------------------------------------------------------------
 
-       lonmin_palm = MINVAL(palm_intermediate % clon)
-       lonmax_palm = MAXVAL(palm_intermediate % clon)
-       latmin_palm = MINVAL(palm_intermediate % clat)
-       latmax_palm = MAXVAL(palm_intermediate % clat)
-
-       CALL init_averaging_grid(averaged_initial_scalar_profile, cosmo_grid,   &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
-               lonmin = lonmin_palm, lonmax = lonmax_palm,                     &
-               latmin = latmin_palm, latmax = latmax_palm,                     &
-               kind='scalar', name='averaged initial scalar')
-
-       CALL init_averaging_grid(averaged_initial_w_profile, cosmo_grid,        &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = zw, z0 = z0,              &
-               lonmin = lonmin_palm, lonmax = lonmax_palm,                     &
-               latmin = latmin_palm, latmax = latmax_palm,                     &
-               kind='w', name='averaged initial w')
-
-       CALL init_averaging_grid(averaged_scalar_profile, cosmo_grid,           &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
-               lonmin = lam_west, lonmax = lam_east,                           &
-               latmin = phi_south, latmax = phi_north,                         &
-               kind='scalar', name='centre geostrophic scalar')
-
-       CALL init_averaging_grid(averaged_w_profile, cosmo_grid,                &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = zw, z0 = z0,              &
-               lonmin = lam_west, lonmax = lam_east,                           &
-               latmin = phi_south, latmax = phi_north,                         &
-               kind='w', name='centre geostrophic w')
-
-       CALL init_averaging_grid(south_averaged_scalar_profile, cosmo_grid,     &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
-               lonmin = lam_west, lonmax = lam_east,                           &
-               latmin = phi_centre - averaging_angle,                          &
-               latmax = phi_centre,                                            &
-               kind='scalar', name='south geostrophic scalar')
-
-       CALL init_averaging_grid(north_averaged_scalar_profile, cosmo_grid,     &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
-               lonmin = lam_west, lonmax = lam_east,                           &
-               latmin = phi_centre,                                            &
-               latmax = phi_centre + averaging_angle,                          &
-               kind='scalar', name='north geostrophic scalar')
-
-       CALL init_averaging_grid(west_averaged_scalar_profile, cosmo_grid,      &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
-               lonmin = lam_centre - averaging_angle,                          &
-               lonmax = lam_centre,                                            &
-               latmin = phi_south, latmax = phi_north,                         &
-               kind='scalar', name='west geostrophic scalar')
-
-       CALL init_averaging_grid(east_averaged_scalar_profile, cosmo_grid,      &
-               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
-               lonmin = lam_centre,                                            &
-               lonmax = lam_centre + averaging_angle,                          &
-               latmin = phi_south, latmax = phi_north,                         &
-               kind='scalar', name='east geostrophic scalar')
+    lonmin_palm = MINVAL(palm_intermediate%clon)
+    lonmax_palm = MAXVAL(palm_intermediate%clon)
+    latmin_palm = MINVAL(palm_intermediate%clat)
+    latmax_palm = MAXVAL(palm_intermediate%clat)
+
+    CALL init_averaging_grid(averaged_initial_scalar_profile, cosmo_grid,   &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = z, z0 = z0,               &
+            lonmin = lonmin_palm, lonmax = lonmax_palm,                     &
+            latmin = latmin_palm, latmax = latmax_palm,                     &
+            kind='scalar', name='averaged initial scalar')
+
+    CALL init_averaging_grid(averaged_initial_w_profile, cosmo_grid,        &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = zw, z0 = z0,              &
+            lonmin = lonmin_palm, lonmax = lonmax_palm,                     &
+            latmin = latmin_palm, latmax = latmax_palm,                     &
+            kind='w', name='averaged initial w')
+
+    CALL init_averaging_grid(averaged_scalar_profile, cosmo_grid,           &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = z, z0 = z0,               &
+            lonmin = lam_west, lonmax = lam_east,                           &
+            latmin = phi_south, latmax = phi_north,                         &
+            kind='scalar', name='centre geostrophic scalar')
+
+    CALL init_averaging_grid(averaged_w_profile, cosmo_grid,                &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = zw, z0 = z0,              &
+            lonmin = lam_west, lonmax = lam_east,                           &
+            latmin = phi_south, latmax = phi_north,                         &
+            kind='w', name='centre geostrophic w')
+
+    CALL init_averaging_grid(south_averaged_scalar_profile, cosmo_grid,     &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = z, z0 = z0,               &
+            lonmin = lam_west, lonmax = lam_east,                           &
+            latmin = phi_centre - averaging_angle,                          &
+            latmax = phi_centre,                                            &
+            kind='scalar', name='south geostrophic scalar')
+
+    CALL init_averaging_grid(north_averaged_scalar_profile, cosmo_grid,     &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = z, z0 = z0,               &
+            lonmin = lam_west, lonmax = lam_east,                           &
+            latmin = phi_centre,                                            &
+            latmax = phi_centre + averaging_angle,                          &
+            kind='scalar', name='north geostrophic scalar')
+
+    CALL init_averaging_grid(west_averaged_scalar_profile, cosmo_grid,      &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = z, z0 = z0,               &
+            lonmin = lam_centre - averaging_angle,                          &
+            lonmax = lam_centre,                                            &
+            latmin = phi_south, latmax = phi_north,                         &
+            kind='scalar', name='west geostrophic scalar')
+
+    CALL init_averaging_grid(east_averaged_scalar_profile, cosmo_grid,      &
+            x = 0.5_wp * lx, y = 0.5_wp * ly, z = z, z0 = z0,               &
+            lonmin = lam_centre,                                            &
+            lonmax = lam_centre + averaging_angle,                          &
+            latmin = phi_south, latmax = phi_north,                         &
+            kind='scalar', name='east geostrophic scalar')
 
 
@@ -1102,50 +1123,49 @@
 ! Section 4: Precompute neighbours and weights for interpolation              
 !------------------------------------------------------------------------------
-       interp_mode = 's'
-       CALL setup_interpolation(cosmo_grid, palm_grid, palm_intermediate, interp_mode, ic_mode=cfg % ic_mode)
-       IF (boundary_variables_required)  THEN
-          CALL setup_interpolation(cosmo_grid, scalars_east_grid, scalars_east_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, scalars_west_grid, scalars_west_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, scalars_north_grid, scalars_north_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, scalars_south_grid, scalars_south_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, scalars_top_grid, scalars_top_intermediate, interp_mode)
-       ENDIF
-
-       interp_mode = 'u'
-       CALL setup_interpolation(cosmo_grid, u_initial_grid, u_initial_intermediate, interp_mode, ic_mode=cfg % ic_mode)
-       IF (boundary_variables_required)  THEN
-          CALL setup_interpolation(cosmo_grid, u_east_grid, u_east_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, u_west_grid, u_west_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, u_north_grid, u_north_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, u_south_grid, u_south_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, u_top_grid, u_top_intermediate, interp_mode)
-       ENDIF
-
-       interp_mode = 'v'
-       CALL setup_interpolation(cosmo_grid, v_initial_grid, v_initial_intermediate, interp_mode, ic_mode=cfg % ic_mode)
-       IF (boundary_variables_required)  THEN
-          CALL setup_interpolation(cosmo_grid, v_east_grid, v_east_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, v_west_grid, v_west_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, v_north_grid, v_north_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, v_south_grid, v_south_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, v_top_grid, v_top_intermediate, interp_mode)
-       ENDIF
-
-       interp_mode = 'w'
-       CALL setup_interpolation(cosmo_grid, w_initial_grid, w_initial_intermediate, interp_mode, ic_mode=cfg % ic_mode)
-       IF (boundary_variables_required)  THEN
-          CALL setup_interpolation(cosmo_grid, w_east_grid, w_east_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, w_west_grid, w_west_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, w_north_grid, w_north_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, w_south_grid, w_south_intermediate, interp_mode)
-          CALL setup_interpolation(cosmo_grid, w_top_grid, w_top_intermediate, interp_mode)
-       ENDIF
-
-       IF (TRIM(cfg % ic_mode) == 'profile')  THEN
-           !TODO: remove this conditional if not needed. 
-       ENDIF
-        
-
-    END SUBROUTINE setup_grids
+    interp_mode = 's'
+    CALL setup_interpolation(cosmo_grid, palm_grid, palm_intermediate, interp_mode, ic_mode=cfg%ic_mode)
+    IF (boundary_variables_required)  THEN
+       CALL setup_interpolation(cosmo_grid, scalars_east_grid, scalars_east_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, scalars_west_grid, scalars_west_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, scalars_north_grid, scalars_north_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, scalars_south_grid, scalars_south_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, scalars_top_grid, scalars_top_intermediate, interp_mode)
+    ENDIF
+
+    interp_mode = 'u'
+    CALL setup_interpolation(cosmo_grid, u_initial_grid, u_initial_intermediate, interp_mode, ic_mode=cfg%ic_mode)
+    IF (boundary_variables_required)  THEN
+       CALL setup_interpolation(cosmo_grid, u_east_grid, u_east_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, u_west_grid, u_west_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, u_north_grid, u_north_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, u_south_grid, u_south_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, u_top_grid, u_top_intermediate, interp_mode)
+    ENDIF
+
+    interp_mode = 'v'
+    CALL setup_interpolation(cosmo_grid, v_initial_grid, v_initial_intermediate, interp_mode, ic_mode=cfg%ic_mode)
+    IF (boundary_variables_required)  THEN
+       CALL setup_interpolation(cosmo_grid, v_east_grid, v_east_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, v_west_grid, v_west_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, v_north_grid, v_north_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, v_south_grid, v_south_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, v_top_grid, v_top_intermediate, interp_mode)
+    ENDIF
+
+    interp_mode = 'w'
+    CALL setup_interpolation(cosmo_grid, w_initial_grid, w_initial_intermediate, interp_mode, ic_mode=cfg%ic_mode)
+    IF (boundary_variables_required)  THEN
+       CALL setup_interpolation(cosmo_grid, w_east_grid, w_east_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, w_west_grid, w_west_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, w_north_grid, w_north_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, w_south_grid, w_south_intermediate, interp_mode)
+       CALL setup_interpolation(cosmo_grid, w_top_grid, w_top_intermediate, interp_mode)
+    ENDIF
+
+    IF (TRIM(cfg%ic_mode) == 'profile')  THEN
+        !TODO: remove this conditional if not needed. 
+    ENDIF
+
+ END SUBROUTINE setup_grids
 
 
@@ -1156,15 +1176,15 @@
 !> vertical interpolation.
 !------------------------------------------------------------------------------!
-    SUBROUTINE setup_interpolation(cosmo_grid, grid, intermediate_grid, kind, ic_mode)
-
-       TYPE(grid_definition), INTENT(IN), TARGET    ::  cosmo_grid
-       TYPE(grid_definition), INTENT(INOUT), TARGET ::  grid, intermediate_grid
-       CHARACTER, INTENT(IN)                        ::  kind
-       CHARACTER(LEN=*), INTENT(IN), OPTIONAL       ::  ic_mode
-
-       REAL(dp), DIMENSION(:), POINTER     ::  cosmo_lat, cosmo_lon
-       REAL(dp), DIMENSION(:,:,:), POINTER ::  cosmo_h
-
-       LOGICAL :: setup_volumetric
+ SUBROUTINE setup_interpolation(cosmo_grid, grid, intermediate_grid, kind, ic_mode)
+
+    TYPE(grid_definition), INTENT(IN), TARGET    ::  cosmo_grid
+    TYPE(grid_definition), INTENT(INOUT), TARGET ::  grid, intermediate_grid
+    CHARACTER, INTENT(IN)                        ::  kind
+    CHARACTER(LEN=*), INTENT(IN), OPTIONAL       ::  ic_mode
+
+    REAL(wp), DIMENSION(:), POINTER     ::  cosmo_lat, cosmo_lon
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  cosmo_h
+
+    LOGICAL :: setup_volumetric
 
 !------------------------------------------------------------------------------
@@ -1172,52 +1192,52 @@
 !------------------------------------------------------------------------------
 !
-!--    Select horizontal coordinates according to kind of points (s/w, u, v)
-       SELECT CASE(kind)
-
-!
-!--    scalars
-       CASE('s')
-
-          cosmo_lat => cosmo_grid % lat
-          cosmo_lon => cosmo_grid % lon
-          cosmo_h   => cosmo_grid % hfl
-!
-!--    vertical velocity
-       CASE('w')
-
-          cosmo_lat => cosmo_grid % lat
-          cosmo_lon => cosmo_grid % lon
-          cosmo_h   => cosmo_grid % hhl
-!
-!--    x velocity
-       CASE('u')
-
-          cosmo_lat => cosmo_grid % lat
-          cosmo_lon => cosmo_grid % lonu
-          cosmo_h   => cosmo_grid % hfl
-
-!
-!--    y velocity
-       CASE('v')
-
-          cosmo_lat => cosmo_grid % latv
-          cosmo_lon => cosmo_grid % lon
-          cosmo_h   => cosmo_grid % hfl
-
-       CASE DEFAULT
-
-          message = "Interpolation quantity '" // kind // "' is not supported."
-          CALL inifor_abort('setup_interpolation', message)
-
-       END SELECT
-
-       CALL find_horizontal_neighbours(cosmo_lat, cosmo_lon,                   &
-          intermediate_grid % clat, intermediate_grid % clon,                  &
-          intermediate_grid % ii, intermediate_grid % jj)
-
-       CALL compute_horizontal_interp_weights(cosmo_lat, cosmo_lon,            &
-          intermediate_grid % clat, intermediate_grid % clon,                  &
-          intermediate_grid % ii, intermediate_grid % jj,                      &
-          intermediate_grid % w_horiz)
+!-- Select horizontal coordinates according to kind of points (s/w, u, v)
+    SELECT CASE(kind)
+
+!
+!-- scalars
+    CASE('s')
+
+       cosmo_lat => cosmo_grid%lat
+       cosmo_lon => cosmo_grid%lon
+       cosmo_h   => cosmo_grid%hfl
+!
+!-- vertical velocity
+    CASE('w')
+
+       cosmo_lat => cosmo_grid%lat
+       cosmo_lon => cosmo_grid%lon
+       cosmo_h   => cosmo_grid%hhl
+!
+!-- x velocity
+    CASE('u')
+
+       cosmo_lat => cosmo_grid%lat
+       cosmo_lon => cosmo_grid%lonu
+       cosmo_h   => cosmo_grid%hfl
+
+!
+!-- y velocity
+    CASE('v')
+
+       cosmo_lat => cosmo_grid%latv
+       cosmo_lon => cosmo_grid%lon
+       cosmo_h   => cosmo_grid%hfl
+
+    CASE DEFAULT
+
+       message = "Interpolation quantity '" // kind // "' is not supported."
+       CALL inifor_abort('setup_interpolation', message)
+
+    END SELECT
+
+    CALL find_horizontal_neighbours(cosmo_lat, cosmo_lon,                   &
+       intermediate_grid%clat, intermediate_grid%clon,                  &
+       intermediate_grid%ii, intermediate_grid%jj)
+
+    CALL compute_horizontal_interp_weights(cosmo_lat, cosmo_lon,            &
+       intermediate_grid%clat, intermediate_grid%clon,                  &
+       intermediate_grid%ii, intermediate_grid%jj,                      &
+       intermediate_grid%w_horiz)
 
 !------------------------------------------------------------------------------
@@ -1226,28 +1246,28 @@
 
 !
-!--    If profile initialization is chosen, we--somewhat counterintuitively--
-!--    don't need to compute vertical interpolation weights. At least, we
-!--    don't need them on the intermediate grid, which fills the entire PALM
-!--    domain volume. Instead we need vertical weights for the intermediate
-!--    profile grids, which get computed in setup_averaging().
-       setup_volumetric = .TRUE.
-       IF (PRESENT(ic_mode))  THEN
-          IF (TRIM(ic_mode) == 'profile')  setup_volumetric = .FALSE.
-       ENDIF
-
-       IF (setup_volumetric)  THEN
-          ALLOCATE( intermediate_grid % h(0:intermediate_grid % nx,            &
-                                          0:intermediate_grid % ny,            &
-                                          0:intermediate_grid % nz) ) 
-          intermediate_grid % h(:,:,:) = - EARTH_RADIUS
-
-!
-!--       For w points, use hhl, for scalars use hfl
-!--       compute the full heights for the intermediate grids
-          CALL interpolate_2d(cosmo_h, intermediate_grid % h, intermediate_grid)
-          CALL find_vertical_neighbours_and_weights_interp(grid, intermediate_grid)
-       ENDIF
-       
-    END SUBROUTINE setup_interpolation
+!-- If profile initialization is chosen, we--somewhat counterintuitively--
+!-- don't need to compute vertical interpolation weights. At least, we
+!-- don't need them on the intermediate grid, which fills the entire PALM
+!-- domain volume. Instead we need vertical weights for the intermediate
+!-- profile grids, which get computed in setup_averaging().
+    setup_volumetric = .TRUE.
+    IF (PRESENT(ic_mode))  THEN
+       IF (TRIM(ic_mode) == 'profile')  setup_volumetric = .FALSE.
+    ENDIF
+
+    IF (setup_volumetric)  THEN
+       ALLOCATE( intermediate_grid%h(0:intermediate_grid%nx,            &
+                                     0:intermediate_grid%ny,            &
+                                     0:intermediate_grid%nz) ) 
+       intermediate_grid%h(:,:,:) = - EARTH_RADIUS
+
+!
+!--    For w points, use hhl, for scalars use hfl
+!--    compute the full heights for the intermediate grids
+       CALL interpolate_2d(cosmo_h, intermediate_grid%h, intermediate_grid)
+       CALL find_vertical_neighbours_and_weights_interp(grid, intermediate_grid)
+    ENDIF
+       
+ END SUBROUTINE setup_interpolation
 
 !------------------------------------------------------------------------------!
